<template>
  <div class="loading" v-show="loading" role="alert">
    <Loading></Loading>
  </div>
  <Nav></Nav>
  <main>
    <transition appear name="fade">
    <div>
      <page-title class="title center" :title="'Traject aanmaken'"></page-title>

      <Paragraph class="paragraph center" :text="'Hieronder in de eerste vak zie je de ' +
     'vakken die je kan kiezen om in jouw traject te steken.' +
      ' In de tweede vak zie je de vakken die je gekozen hebt.' +
       '   Om daar nog vakken toe te voegen klik op de vakken in het eerste vak' +
        ' en dan worden ze toegevoegd in de gekozen vakken.' +
         ' Klik op Verder om nog verder te gaan met jouw traject op te bouwen.'"></Paragraph>
      <Paragraph class="paragraph left"
                 :text="' Klik op Verder om nog verder te ' +
                'gaan met jouw traject op te bouwen.'"></Paragraph>

      <div v-show="first">
        <h2 class="center title-2">Fase 1</h2>
        <h2 class="left">Vakken in het eerste semester</h2>
        <SubjectsList :subjects="subjectsS1PH1"></SubjectsList>
        <h2 class="left">Gekozen vakken voor het eerste semester</h2>
        <h3 class="right">{{ totalCreditS1PH1 }}/33 studiepunten</h3>
        <SubjectsList :subjects="chosenSubjectsS1PH1" class="disabled-click"></SubjectsList>

        <h2 class="left">Vakken in het tweede semester</h2>
        <SubjectsList :subjects="subjectsS2PH1"></SubjectsList>
        <h2 class="left">Gekozen vakken voor het tweede semester</h2>
        <h3 class="right">{{ totalCreditS2PH1 }}/33 studiepunten</h3>
        <SubjectsList :subjects="chosenSubjectsS2PH1" class="disabled-click"></SubjectsList>

        <div class="center btn">
          <prime-button :value='btnValue' @click="actionPH1"></prime-button>
        </div>
      </div>

      <div v-show="second">
        <h2 class="center title-2">Fase 2</h2>
        <h2 class="left">Vakken in het eerste semester</h2>
        <SubjectsList :subjects="subjectsS1PH2"></SubjectsList>
        <h2 class="left">Gekozen vakken voor het eerste semester</h2>
        <h3 class="right">{{ totalCreditS1PH2 }}/33 studiepunten</h3>
        <SubjectsList :subjects="chosenSubjectsS1PH2" class="disabled-click"></SubjectsList>

        <h2 class="left">Vakken in het tweede semester</h2>
        <SubjectsList :subjects="subjectsS2PH2"></SubjectsList>
        <h2 class="left">Gekozen vakken voor het tweede semester</h2>
        <h3 class="right">{{ totalCreditS2PH2 }}/33 studiepunten</h3>
        <SubjectsList :subjects="chosenSubjectsS2PH2" class="disabled-click"></SubjectsList>

        <div class="center btn">
          <prime-button :value='btnValue' @click="actionPH2"></prime-button>
        </div>
        <div class="center btn">
          <prime-button :value="'Vorige'" @click="goBack(2)"></prime-button>
        </div>
      </div>

      <div v-show="third">
        <h2 class="center title-2">Fase 3</h2>
        <h2 class="left">Vakken in het eerste semester</h2>
        <SubjectsList :subjects="subjectsS1PH3"></SubjectsList>
        <h2 class="left">Gekozen vakken voor het eerste semester</h2>
        <h3 class="right">{{ totalCreditS1PH3 }}/30 studiepunten</h3>
        <SubjectsList :subjects="chosenSubjectsS1PH3" class="disabled-click"></SubjectsList>

        <h2 class="left">Vakken in het tweede semester</h2>
        <SubjectsList :subjects="subjectsS2PH3"></SubjectsList>
        <h2 class="left">Gekozen vakken voor het tweede semester</h2>
        <h3 class="right">{{ totalCreditS2PH3 }}/33 studiepunten</h3>
        <SubjectsList :subjects="chosenSubjectsS2PH3" class="disabled-click"></SubjectsList>

        <div class="center btn">
          <prime-button :value='"Opslaan"' @click="actionPH3"></prime-button>
        </div>
        <div class="center btn">
          <prime-button :value="'Vorige'" @click="goBack(3)"></prime-button>
        </div>
      </div>
    </div>
    </transition>
  </main>

  <Footer></Footer>
</template>

<script>
import Nav from '@/components/UI/organisms/Nav.vue';
import PageTitle from '@/components/UI/atoms/PageTitle.vue';
import Paragraph from '@/components/UI/atoms/Paragraph.vue';
import SubjectsList from '@/components/UI/organisms/SubjectsList.vue';
import PrimeButton from '@/components/UI/atoms/PrimeBtn.vue';
import Footer from '@/components/UI/organisms/Footer.vue';
import Loading from '@/components/UI/atoms/Loading.vue';

import auth from '@/store/modules/auth';

import { mapGetters, mapActions } from 'vuex';

export default {
  /* eslint-disable */
  name: 'Dashboard',
  components: {
    Loading,
    Footer,
    PrimeButton,
    SubjectsList,
    Paragraph,
    PageTitle,
    Nav,
  },
  data() {
    return {
      btnValue: 'Volgende',
      loading: false,
      first: true,
      second: false,
      third: false,
    };
  },
  methods: {
    ...mapGetters('subjects', ['subjects']),
    ...mapGetters('subjects', ['chosenSubjects']),
    ...mapActions('trajectories', ['addTrajectory']),

    actionPH1() {
      if (this.totalCreditS1PH1 < 30) {
        alert('Te weining vakken geselecteerd voor het eerste semester');
      } else if (this.totalCreditS1PH1 > 33) {
        alert('Te veel vakken geselecteerd voor het eerste semester');
      } else if (this.totalCreditS2PH1 < 30) {
        alert('Te weining vakken geselecteerd voor de tweede semester');
      } else if (this.totalCreditS2PH1 > 33) {
        alert('Te veel vakken geselecteerd voor de tweede semester');
      } else {
        this.first = false;
        this.second = true;
        window.scrollTo(0, 0);
      }
    },

    actionPH2() {
      if (this.totalCreditS1PH2 < 30) {
        alert('Te weining vakken geselecteerd voor het eerste semester');
      } else if (this.totalCreditS1PH2 > 33) {
        alert('Te veel vakken geselecteerd voor het eerste semester');
      } else if (this.totalCreditS2PH2 < 30) {
        alert('Te weining vakken geselecteerd voor de tweede semester');
      } else if (this.totalCreditS2PH2 > 33) {
        alert('Te veel vakken geselecteerd voor de tweede semester');
      } else {
        this.second = false;
        this.third = true;
        window.scrollTo(0, 0);
      }
    },

    async actionPH3() {
      if (this.totalCreditS1PH3 < 30) {
        alert('Te weining vakken geselecteerd voor het eerste semester');
      } else if (this.totalCreditS1PH3 > 33) {
        alert('Te veel vakken geselecteerd voor het eerste semester');
      } else if (this.totalCreditS2PH3 < 30) {
        alert('Te weining vakken geselecteerd voor de tweede semester');
      } else if (this.totalCreditS2PH3 > 33) {
        alert('Te veel vakken geselecteerd voor de tweede semester');
      } else if (this.chosenSubjects().reduce((sum, subject) => sum + subject.credit, 0) > 180) {
        alert('Te veel vakken geselecteerd voor dit traject. Je mag max 180 studiepunten selecteren voor heel de trajecr.');
      } else if (!auth.state.user) {
        console.log('not logged in');
        await this.$router.push({ name: 'Login', query: { redirect: '/nieuwtraject' } });
      } else {
        this.loading = true;
        const subjects = [];
        // eslint-disable-next-line no-return-assign
        await this.chosenSubjects().forEach((subject) => subjects.push(subject.id));
        try {
          await this.addTrajectory(subjects);
        } finally {
          await this.chosenSubjects().splice(this.chosenSubjects());
          await this.$store.dispatch('trajectories/getTrajectories');
          await this.$router.push({ name: 'Trajectories' });
        }
      }
    },

    goBack(id) {
      if (id === 2) {
        this.second = false;
        this.first = true;
      }
      if (id === 3) {
        this.third = false;
        this.second = true;
      }
      window.scrollTo(0, 0);
    },
  },
  computed: {
    // Phase 1 -------------------------------------------------------------------------------------
    subjectsS1PH1() {
      return this.subjects().filter((subject) => subject.phase === 1 && subject.semester === 'first');
    },
    chosenSubjectsS1PH1() {
      return this.chosenSubjects().filter((subject) => subject.phase === 1 && subject.semester === 'first');
    },
    totalCreditS1PH1() {
      const subjects = this.chosenSubjects().filter((subject) => subject.phase === 1 && subject.semester === 'first');
      const total = subjects.reduce((sum, subject) => sum + subject.credit, 0);
      return total;
    },

    subjectsS2PH1() {
      return this.subjects().filter((subject) => subject.phase === 1 && subject.semester === 'second');
    },
    chosenSubjectsS2PH1() {
      return this.chosenSubjects().filter((subject) => subject.phase === 1 && subject.semester === 'second');
    },
    totalCreditS2PH1() {
      const subjects = this.chosenSubjects().filter((subject) => subject.phase === 1 && subject.semester === 'second');
      const total = subjects.reduce((sum, subject) => sum + subject.credit, 0);
      return total;
    },

    // Phase 2 -------------------------------------------------------------------------------------
    subjectsS1PH2() {
      return this.subjects().filter((subject) => subject.phase === 2 && subject.semester === 'first');
    },
    chosenSubjectsS1PH2() {
      return this.chosenSubjects().filter((subject) => subject.phase === 2 && subject.semester === 'first');
    },
    totalCreditS1PH2() {
      const subjects = this.chosenSubjects().filter((subject) => subject.phase === 2 && subject.semester === 'first');
      const total = subjects.reduce((sum, subject) => sum + subject.credit, 0);
      return total;
    },

    subjectsS2PH2() {
      return this.subjects().filter((subject) => subject.phase === 2 && subject.semester === 'second');
    },
    chosenSubjectsS2PH2() {
      return this.chosenSubjects().filter((subject) => subject.phase === 2 && subject.semester === 'second');
    },
    totalCreditS2PH2() {
      const subjects = this.chosenSubjects().filter((subject) => subject.phase === 2 && subject.semester === 'second');
      const total = subjects.reduce((sum, subject) => sum + subject.credit, 0);
      return total;
    },

    // Phase 3 -------------------------------------------------------------------------------------
    subjectsS1PH3() {
      return this.subjects().filter((subject) => subject.phase === 3 && subject.semester === 'first');
    },
    chosenSubjectsS1PH3() {
      return this.chosenSubjects().filter((subject) => subject.phase === 3 && subject.semester === 'first');
    },
    totalCreditS1PH3() {
      const subjects = this.chosenSubjects().filter((subject) => subject.phase === 3 && subject.semester === 'first');
      const total = subjects.reduce((sum, subject) => sum + subject.credit, 0);
      return total;
    },

    subjectsS2PH3() {
      return this.subjects().filter((subject) => subject.phase === 3 && subject.semester === 'second');
    },
    chosenSubjectsS2PH3() {
      return this.chosenSubjects().filter((subject) => subject.phase === 3 && subject.semester === 'second');
    },
    totalCreditS2PH3() {
      const subjects = this.chosenSubjects().filter((subject) => subject.phase === 3 && subject.semester === 'second');
      const total = subjects.reduce((sum, subject) => sum + subject.credit, 0);
      return total;
    },
  },

  async created() {
    const total = this.chosenSubjects().reduce((sum, subject) => sum + subject.credit, 0);
    if (total === 180) {
      this.loading = true;
      const subjects = [];
      // eslint-disable-next-line no-return-assign
      await this.chosenSubjects().forEach((subject) => subjects.push(subject.id));
      try {
        await this.addTrajectory(subjects);
      } finally {
        await this.chosenSubjects().splice(this.chosenSubjects());
        await this.$store.dispatch('trajectories/getTrajectories');
        await this.$router.push({ name: 'Trajectories' });
      }
    }
  },
};
</script>

<style scoped>
  .center{
    text-align: center;
  }
  .left{
    text-align: left;
    margin-left: 13%;
  }
  .right{
    text-align: right;
    margin-right: 13%;
    font-family: 'Roboto', sans-serif;
    font-size: 1.5em;
    color: #3BB497;
  }
  .paragraph{
    max-width: 500px;
    margin: 20px auto;
  }
  .title{
    margin-top: 60px;
  }
  h2{
    margin: 40px 0 20px 0 ;
    font-family: 'Roboto', sans-serif;
    font-size: 2em;
    color: #3BB497;
  }
  .title-2{
    margin-top: 60px;
    font-size: 3em;
    color: #09639B;
  }
  .btn{
    margin-top: 20px;
  }

</style>
